package v2.name.panitz.wip.stackmachine;
import  v2.name.panitz.wip.stackmachine.Instruction.Instr;
import java.io.*;

public class WriteX86{
  public boolean _32 = true;

  String mov(){return _32?"movl":"movq";}
  String ax(){return _32?"%eax":"%rax";}
  String bx(){return _32?"%ebx":"%rbx";}
  String cx(){return _32?"%ecx":"%rcx";}
  String sp(){return _32?"%esp":"%rsp";}
  String bp(){return _32?"%ebp":"%rbp";}
  String push(){return _32?"pushl":"pushq";}
  String pop(){return _32?"popl":"popq";}
  String mul(){return _32?"mull":"mulq";}

  public Instruction[] code;
  public WriteX86(Instruction[] code){
    this.code = code;
  }

  public void writeAssembler(Writer out)throws Exception{
    out.write(".globl go\n");
    out.write("go:\n");
    out.write("   "+push()+"   "+bp()+"\n");
    out.write("   "+mov()+"    "+sp()+", "+bp()+"\n");

    for (Instruction in:code){
      writeAssembler(out,in);
    }

    out.write("   "+pop()+"    "+ax()+"\n");
    out.write("   "+pop()+"    "+bp()+"\n");
    out.write("   ret\n");
    out.close();
  }


  public void writeAssembler(Writer out,Instruction ins)throws Exception{
    switch (ins.instr) {
    case PushInt: out.write("   "+push()+"   $"+ins.a1+"\n");break;
    case Mult: 
      out.write("   "+pop()+"   "+bx()+"\n");
      out.write("   "+pop()+"   "+ax()+"\n");
      out.write("   "+mul()+"   "+bx()+"\n");
      out.write("   "+push()+"   "+ax()+"\n");
      break;
    }
  }
}

