package v3.name.panitz.wip.stackmachine;

public class StackMachine{
  public Instruction[] code;
  int ic = 0;
  int[] stack = new int[200];
  int stc = 0;
  int stb = 0;

  void step(){
    switch (code[ic].instr) {
    case PushInt: stack[stc++] = code[ic].a1;ic++;break;
    case Mult: stack[stc-2] = stack[stc-2] * stack[stc-1];stc--;ic++;break;  
    case Mod:  stack[stc-2] = stack[stc-2] % stack[stc-1];stc--;ic++;break;  
    case Div:  stack[stc-2] = stack[stc-2] / stack[stc-1];stc--;ic++;break;  
    case Add:  stack[stc-2] = stack[stc-2] + stack[stc-1];stc--;ic++;break;  
    case Sub:  stack[stc-2] = stack[stc-2] - stack[stc-1];stc--;ic++;break;  
    case Eq:   stack[stc-2] = stack[stc-2] == stack[stc-1]?1:0;stc--;ic++;break;  
    case Neq:  stack[stc-2] = stack[stc-2] != stack[stc-1]?1:0;stc--;ic++;break;  
    case Lt:   stack[stc-2] = stack[stc-2] < stack[stc-1]?1:0;stc--;ic++;break;  
    case Gt:   stack[stc-2] = stack[stc-2] > stack[stc-1]?1:0;stc--;ic++;break;  
    case Le:   stack[stc-2] = stack[stc-2] <= stack[stc-1]?1:0;stc--;ic++;break;  
    case Ge:   stack[stc-2] = stack[stc-2] >= stack[stc-1]?1:0;stc--;ic++;break;  
    case And:  stack[stc-2] = (stack[stc-2]==1 && 1==stack[stc-1])?1:0;stc--;ic++;break;  
    case Or:   stack[stc-2] = (stack[stc-2]==1 || 1==stack[stc-1])?1:0;stc--;ic++;break;  
    }
  }

  public void run(){
    while (ic<code.length){
      step();
    }
    System.out.println(stack[0]);
  }

  public static void main(String[] args){
    StackMachine interp = new StackMachine();
    interp.code = new Instruction[1];
    interp.code[0] = new Instruction(Instruction.Instr.PushInt,42);
    interp.run();
  }  
}

