package v3.name.panitz.wip.tree;
import v3.name.panitz.wip.stackmachine.*;

import java.util.List;
import java.util.LinkedList;

public class GenCode implements Visitor<List<Instruction>>{
  List<Instruction> result = new LinkedList<>();

  public List<Instruction> visit(IntLit il) {
    result.add(new Instruction(Instruction.Instr.PushInt,il.i));
    return result;
  }

  public void visit(OpExpr ex) throws Exception{
    ex.left.welcome(this);
    ex.right.welcome(this);
  }
  public List<Instruction> visit(MultExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Mult));
    return result;
  }

  public List<Instruction> visit(DivExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Div));
    return result;
  }
  public List<Instruction> visit(ModExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Mod));
    return result;
  }
  public List<Instruction> visit(AddExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Add));
    return result;
  }
  public List<Instruction> visit(SubExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Sub));
    return result;
  }
  public List<Instruction> visit(EqExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Eq));
    return result;
  }
  public List<Instruction> visit(NeqExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Neq));
    return result;
  }
  public List<Instruction> visit(LeExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Le));
    return result;
  }
  public List<Instruction> visit(GeExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Ge));
    return result;
  }
  public List<Instruction> visit(LtExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Lt));
    return result;
  }
  public List<Instruction> visit(GtExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Gt));
    return result;
  }
  public List<Instruction> visit(OrExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.Or));
    return result;
  }
  public List<Instruction> visit(AndExpr ex) throws Exception{
    visit((OpExpr) ex);
    result.add(new Instruction(Instruction.Instr.And));
    return result;
  }
}

