package v4.name.panitz.wip.tree;

import java.util.List;
import java.util.LinkedList;
import java.io.*;

public class Interpreter implements Visitor<Integer>{
  int result = 0;

  public Integer visit(IntLit il) throws Exception{
    return il.i;
  }

  public Integer visit(IfExpr ex) throws Exception{
    int p = ex.cond.welcome(this);
    if (p==1) return ex.alt1.welcome(this);
    return ex.alt2.welcome(this);
  }

  public Integer visit(OpExpr ex) throws Exception{
    int op1 = ex.left.welcome(this);
    int op2 = ex.right.welcome(this);
    return ex.op.applyAsInt(op1, op2);
  }
  public Integer visit(MultExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(DivExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(ModExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(AddExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(SubExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(EqExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(NeqExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(LeExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(GeExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(LtExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(GtExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(OrExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(AndExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
}

