package v4.name.panitz.wip.tree;

import java.util.List;
import java.util.LinkedList;
import java.io.*;

public class PP implements Visitor<Integer>{
  int indent = 0;
  Writer w;
  public PP(Writer w){
    this.w = w;
  }

  public Integer visit(IntLit il) throws Exception{
    w.write(il.i+"");
    return indent;
  }

  public Integer visit(OpExpr ex) throws Exception{
    w.write("(");
    ex.left.welcome(this);
    w.write(" "+ex.opName+" ");
    ex.right.welcome(this);
    w.write(")");
    return indent;
  }
  public Integer visit(MultExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(DivExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(ModExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(AddExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(SubExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(EqExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(NeqExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(LeExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(GeExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(LtExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(GtExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(OrExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(AndExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }

  public Integer visit(IfExpr ex) throws Exception{
    w.write("if");
    indent+=2;
    newLine();
    ex.cond.welcome(this);
    indent-=2;
    newLine();
    w.write("then");
    indent+=2;
    newLine();
    ex.alt1.welcome(this);
    indent-=2;
    newLine();
    w.write("else");
    indent+=2;
    newLine();
    ex.alt2.welcome(this);
    indent-=2;
    return indent;
  }
  private void newLine() throws Exception{
    w.write("\n");
    for (int i=0;i<indent;i++) w.write(" ");
  }
}

