package v5.name.panitz.wip.tree;

import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.io.*;

public class Interpreter extends AbstractVisitor<Integer>{
  int result = 0;
  Map<String,Integer> varEnv = new HashMap<>();;
  Map<String,FunDef> funs = new HashMap<>();

  public Integer visit(Program prog) throws Exception{
    funs = prog.welcome(new CollectFunDefs());
    
    return new FunCall("go",new LinkedList<>()).welcome(this);
  }

  public Integer visit(Var v) throws Exception{  
    result = varEnv.get(v.name);
    return result;
  }

  public Integer visit(FunCall f) throws Exception{
    FunDef fun = funs.get(f.name);
    Map<String,Integer> oldEnv = varEnv;
    HashMap<String,Integer> newEnv = new HashMap<>();
    Iterator<Tree> params = f.args.iterator();

    for (String arg:fun.args){
      int v = params.next().welcome(this);
      System.out.println(arg+"="+v);
      newEnv.put(arg,v);
    }
    varEnv = newEnv;
    result =  fun.def.welcome(this);
    varEnv = oldEnv;
    return result;
  }

  public Integer visit(IntLit il) throws Exception{
    return il.i;
  }

  public Integer visit(IfExpr ex) throws Exception{
    int p = ex.cond.welcome(this);
    if (p==1) return ex.alt1.welcome(this);
    return ex.alt2.welcome(this);
  }

  public Integer visit(OpExpr ex) throws Exception{
    int op1 = ex.left.welcome(this);
    int op2 = ex.right.welcome(this);
    return ex.op.applyAsInt(op1, op2);
  }
  public Integer visit(MultExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(DivExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(ModExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(AddExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(SubExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(EqExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(NeqExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(LeExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(GeExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(LtExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(GtExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(OrExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
  public Integer visit(AndExpr ex) throws Exception{
    return visit((OpExpr)ex);
  }
}

