package v6.name.panitz.wip;
import v6.name.panitz.wip.tree.*;
import v6.name.panitz.wip.stackmachine.*;
import java.util.*;
import java.io.*;

public class Main{
  public static void main(String[] args) throws Exception{
    WIPParser parser = null;
    if (args.length == 0){
      parser = new WIPParser(System.in);
    }else {
      parser = new WIPParser(new FileReader(args[0]));
    }
    Tree il = parser.prog();

    StringWriter out  = new StringWriter();
    PP pp = new PP(out);
    il.welcome(pp);
    System.out.println(out);

    System.out.println(il.welcome(new Interpreter()));

    GenCode genCode = new GenCode();
    List<Instruction> code = il.welcome(genCode);
    
    StackMachine st = genCode.getStackMachine();
    System.out.println(st);

    st.run();

    WriteX86 asm = new WriteX86(st.code);
    FileWriter asmf = new FileWriter("test.s");
    asm.writeAssembler(asmf);

    WriteX86 asm64 = new WriteX86(st.code);
    asm64._32 = false;
    FileWriter asmf64 = new FileWriter("test64.s");
    asm64.writeAssembler(asmf64);
  }
}

