package v7.name.panitz.wip.tree;

import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.io.*;
import java.util.stream.Collectors;
import java.util.function.Function;
import static v7.name.panitz.wip.tree.ExceptionFunction.tryCatch;

public class GlobalizeLambda extends Copy{
  List<FunDef> lambdaFuns = new LinkedList<>();

  public Tree visit(Program prog) throws Exception{
    Program p = (Program)super.visit(prog);
    p.funs.addAll(lambdaFuns);
    return p;
  }

  int nr = 0;
  String lambdaFun(){
    return "lambda"+(nr++);
  }

  public Tree visit(LambdaExpr lambda) throws Exception{
    String lambdaName = lambdaFun(); 
    FunDef f = new FunDef(lambdaName,lambda.args,lambda.def.welcome(this));
    lambdaFuns.add(f);    
    return new Var(lambdaName);
  }
}

